if (navigator.userAgent === undefined) {
  navigator.__defineGetter__('userAgent', function() {
    return("Mozilla/5.0 (iPhone; CPU iPhone OS 8_0 like Mac OS X) AppleWebKit");
  });
};

var log = function() {
  try {
    if (typeof Error.captureStackTrace != 'undefined') {
      Error.captureStackTrace(arguments);
    }
    console.log(JSON.stringify([arguments, arguments.stack]));
  } catch (e) {}
};

var pageSize = 25;
var apiSize = 100;
var timeBetweenRefreshes = 10000;
var cts = {};

cts.env = {
  alerts: 'https://maddenmobile.service.easports.com/',
  identity: 'https://maddenmobile.service.easports.com/',
  channels: 'https://maddenmobile.service.easports.com/',
  marketing: 'https://maddenmobile.service.easports.com/marketing/portal/api/'
};

var configIosEnv = 'https://config.easports.com/madden_marketing/iOS/config.json';
var configAndroidEnv = 'https://config.easports.com/madden_marketing/android/config.json';

cts.skus = {
  ps4: 'MAD15PS4',
  xbox: 'MAD15XBO',
  pc: '742A0001'
};

var packages = {};
packages.appInfo = {
  iOS: {
    madden: {
      appId: 'ea55374://',
      package: 'maddennflmobile'
    },
    smartglass: {
      appId: 'smartglass://',
      package: 'xboxonesmartglass'
    },
    ps4app: {
      appId: 'com.playstation.PlaystationApp://',
      package: 'playstationapp'
    }
  },
  android: {
    madden: {
      appId: 'com.ea.game.maddenmobile15_row',
      package: 'com.ea.game.maddenmobile15_row'
    },
    smartglass: {
      appId: 'com.microsoft.xboxone.smartglass',
      package: 'com.microsoft.xboxone.smartglass'
    },
    ps4app: {
      appId: 'com.scee.psxandroid',
      package: 'com.scee.psxandroid'
    }
  },
  unified: {}
};

var tracking = {};
tracking.GA = {
  id: 'UA-24487626-13'
};

var links = {};
links.eula = 'http://tos.ea.com/legalapp/mobileeula/US/en/GM/';
links.ioseula = 'http://tos.ea.com/legalapp/mobileeula/US/en/OTHER';
links.tos = 'http://tos.ea.com/legalapp/WEBTERMS/US/en/PC/';
links.cookies = 'http://tos.ea.com/legalapp/WEBPRIVACY/US/en/PC/';
links.help = 'http://help.ea.com/en/madden/madden-2015/';

cts.keys = {
  alerts: {
    ps: 'k9nbbiE2QjjAsgQIYb1rvGKe67wr3gOQHZN1BLX3',
    xbox: '6o2NEl7hbdeQo8qXFUB7uzeQNyUgPjDgWFS658ZK'
  },
  channels: {
    ps: '7mqvtwrseghkoi0p15s3eitr5lg4h3tidea00gic',
    xbox: 'g5lhr9si3lkgks4maaqn2ch32u9cbezcrfvaya50'
  },
  marketing: {
    appId: 2
  }
};

var eadp = {};
eadp.connect = 'https://accounts.ea.com/connect/';
eadp.gateway = 'https://gateway.ea.com:443/proxy/identity/';

eadp.id = 'MaddenCompanionApp-DEV';
eadp.secret = 'x2FBtqCDFTWAbd3AC5dSWgayANtPwfHcAgvXcNfKbQLLFkTMA8Vy7V7HcaqwjjrB22wpA48kFaWpAQ2y';
eadp.redirectBase = 'http://127.0.0.1/';

var push = {
    gcm: {
      id: 'com.ea.game.maddencompanion_row',
      number: '528237519571'
    },
    apn: {
      id: 'com.ea.maddencompanion.bv'
    }
};

Storage.prototype.setObject = function(name, object) {
  return localStorage.setItem(name, JSON.stringify(object, null));
};

Storage.prototype.getObject = function(name) {
  return JSON.parse(localStorage.getItem(name));
};

window.trackEvents = [];

var nativePluginResultHandler = function (result) {
  //alert('nativePluginResultHandler - '+result);
  window.trackEvents.push('nativePluginResultHandler: '+result);
};

var nativePluginErrorHandler = function (error) {
  //alert('nativePluginErrorHandler - '+error);
  window.trackEvents.push('nativePluginErrorHandler: '+error);
};

var gaPlugin;

var MaddenCompanionApp = angular.module('MaddenCompanionApp', ['ngTouch', 'angularMoment', 'puller']);

MaddenCompanionApp.config(function($interpolateProvider) {
  $interpolateProvider.startSymbol('[[').endSymbol(']]');
});

MaddenCompanionApp.factory('formRequest', function() {
  var formRequest = {};

  formRequest.urlEncode = function(data) {
    var str = [];
    for(var p in data) {
      str.push(encodeURIComponent(p) + "=" + encodeURIComponent(data[p]));
    }

    return str.join("&");
  };

  formRequest.sameQueryTransform = function(dataset) {
    var str = [];
    var values = dataset.values;
    for (var i = 0; i < values.length; i++) {
      str.push(dataset.paramName + '=' + dataset.prefix + encodeURIComponent(values[i]));
    };

    return str.join("&");
  };

  formRequest.urlDecode = function(stringy, shift) {
    var params = stringy.split(/[\#\?\&]/);
    if (shift) {
      params.shift(); //shift off the first
    }
    var paramsObject = {};
    for ( i = 0; i < params.length; i++) {
      paramsObject[params[i].split('=')[0]] = params[i].split('=')[1];
    };
    return paramsObject;
  };

  formRequest.form = function(data, getHeaders) {
    var headers = getHeaders();
    headers['Content-Type'] = 'application/x-www-form-urlencoded;charset=utf-8';
    headers['Accept'] = 'text/xml,application/json,text/plain;charset=utf-8';
    return formRequest.urlEncode(data);
  };

  return formRequest;
});

MaddenCompanionApp.factory('messageService', [function() {
  var self = {};

  self.reload = function(pageMeta) {
    pageMeta.queuedMessages = [];
    pageMeta.viewPage = 1;
    pageMeta.apiPage = 1;
    pageMeta.running = true;
    pageMeta.count = Infinity;
    return pageMeta.apiCall(1);
  };

  self.nextPage = function(pageMeta, messages) {
    if (pageMeta.running) {
      return false;
    }
    if (messages.length == 0) {
      pageMeta.running = false;

      return false; //we arnt really paging are we
    }
    var queuedMessages = pageMeta.queuedMessages;
    pageMeta.viewPage++;
    pageMeta.addedVisuallySize = 0;
    if (queuedMessages.length > 0) {
      var toDisplay = queuedMessages.splice(0, pageMeta.viewSize);
      pageMeta.addedVisuallySize = toDisplay.length;
      angular.extend(messages, messages.concat(toDisplay));
    }

    var remaining = pageMeta.viewSize - pageMeta.addedVisuallySize;
    if (remaining <= 0) {
      pageMeta.running = false;

      return false;
    }
    if (((pageMeta.apiPage + 1) * pageMeta.apiSize) < pageMeta.count) {
      pageMeta.running = true;
      pageMeta.apiPage++;
      pageMeta.apiCall(pageMeta.apiPage);
    }
  };

  self.messageProcessor = function(response, pageMeta, messageBucket) {
    var messages = [];
    var processor = [];
    pageMeta.count = response[pageMeta.countName];
    pageMeta.running = false;

    for (var i = 0; i < response.events.length; i++) {
      var message = {};
      var currentMessage = response.events[i];
      message.date = new Date(parseInt(currentMessage.created_date));
      var attribute = {};
      for(var j = 0; j < currentMessage.attributes.length; j++) {
        attribute[currentMessage.attributes[j].name] = currentMessage.attributes[j].value;
      }
      if (typeof attribute.mobile_body == 'undefined') {
        continue;
      }
      message.content = attribute.mobile_body;
      attribute.type = attribute.type.toLowerCase();
      switch(attribute.type) {
        case 'mut':
          switch (attribute.sub_type) {
            case 'task':
              message.icon = 'img/Icons_MUT_Task.png';
              break;
            case 'reward':
              message.icon = 'img/Icons_Misc_Reward.png';
              break;
            default:
              message.icon = 'img/Icons_MUT_MUT.png';
          }
          switch (attribute.event_type) {
            case 'mut_seasons_win_streak':
            case 'mut_rare_card_acquired':
              message.icon = 'img/Icons_Misc_Reward.png';
              break;
            case 'mut_auction_complete':
            case 'mut_auction_expired':
            case 'mut_auction_bid':
            case 'mut_auction_bidder_lost':
              message.icon = 'img/Icons_MUT_Auction.png';
              break;
            case 'mut_trade_offer':
            case 'mut_trade_offer_cancelled':
            case 'mut_trade_expired':
            case 'mut_trade_offer_answer':
              message.icon = 'img/Icons_MUT_Trade.png';
              break;
          }
          break;
        case 'cfm':
          message.icon = 'img/Icons_CFM_Events.png';
          break;
        case 'ea':
          message.icon = 'img/Icons_Misc_News.png'
          break;
        default:
          message.type = 'madden';
      };
      message.previewText = attribute.mobile_preview;
      if (message.content.indexOf('<ITEM NAME>') !== -1) {
        message.content = message.content.replace(/<ITEM NAME>/g, attribute.item_name);
      }
      if (message.content.indexOf('<GAMERTAG>') !== -1) {
        message.state = 'needsProcessing';
        message.gamerTagId = attribute.gamertag;
        message.processed = false;
      } else {
        message.processed = true;
      }
      messages.push(message);
    };
    //display or queue
    var remainingSize = pageMeta.viewSize - pageMeta.addedVisuallySize;
    //@TODO: next piece works but may be simplified
    if (remainingSize <= 0) {
      angular.extend(pageMeta.queuedMessages, pageMeta.queuedMessages.concat(messages));
    } else if (messages.length > remainingSize) {
      pageMeta.addedVisuallySize = 0;
      angular.extend(messageBucket, messageBucket.concat(messages.splice(0, remainingSize)));
      angular.extend(pageMeta.queuedMessages, pageMeta.queuedMessages.concat(messages));
    } else {
      angular.extend(messageBucket, messageBucket.concat(messages));
      pageMeta.addedVisuallySize += messages.length;
      if (((pageMeta.apiPage + 1) * pageMeta.apiSize) < pageMeta.count) {
        pageMeta.running = true;
        pageMeta.apiPage++;
        pageMeta.apiCall(pageMeta.apiPage);
      }
    }
  };

  return self;
}]);

MaddenCompanionApp.factory('authService', [
    '$rootScope',
    '$q',
    'stateService',
    'ctsService',
    'eadpService',
    'marketingService',
  function(
    $rootScope,
    $q,
    stateService,
    ctsService,
    eadpService,
    marketingService
  ) {

  var self = {};

  var registerPortal = false;

  self.getPersonas = function() {
    var getPersonas = function() {
      if (stateService.getMaddenEntitled()) {
        eadpService.getPersonas();
      }
    };
    var getEntitlement = function() {
      (eadpService.getPidEntitlement())['finally'](getPersonas);
    };
    var getPid = function() {
      (eadpService.getPid())['finally'](getEntitlement);
    };
    (stateService.getAccessToken())['finally'](getPid);
  };

  self.newPersonaSetup = function() {
    eadpService.reAuthWithPid();
    registerPortal = true;
  };

  self.getEaswToken = function(event) {
    if (stateService.hasTokenExpired()) {
      if (localStorage.getItem('refreshToken')) {
        eadpService.refreshAccessToken();
      }
    } else {
      ctsService.getEaswToken(true);
    }
  };

  self.updateEaswToken = function(event) {
    ctsService.getEaswToken('easwTokenUpdated');
  };

  self.registerMobileGateway = function(event) {
    ctsService.mobileGatewayRegister();
  };

  self.refreshAccessToken = function(deferred) {
    eadpService.refreshAccessToken();
  };

  self.getChannelFeed = function() {
    ctsService.getUserFeeds()
      .success(function(response) {
        if (!response.hasOwnProperty('feeds')) {
          throw 'Channels did not return feeds';
        }
        var feedId = false;
        var chansCount = 0;
        for(var i = 0; i < response.count; i++) {
          if (response.feeds[i].name == 'ALL') {
            var feedId = response.feeds[i].id;
            break;
          };
          if (chansCount < response.feeds[i].channels.length) {
            var feedId = response.feeds[i].id;
            chansCount = response.feeds[i].channels.length;
          };
        };
        if (!feedId) {
          log(response);
          $rootScope.$broadcast('socialError');
          throw 'Could not find "ALL" feed';
        };
        stateService.setFeedId(feedId);
        self.getSocial(1);
      })
      .error(function(response) {
        log(response);
        $rootScope.$broadcast('socialError');
      });
  };

  self.getNews = function(page) {
    ctsService.getAlerts(page)
    .success(function(response) {
        if (response.hasOwnProperty('events')) {
          $rootScope.$broadcast('news', response);
        };
    })
    .error(function(response) {
        $rootScope.$broadcast('newsError');
    });
  };

  self.getSocial = function(page) {
    ctsService.getFeed(page)
      .success(function(response) {
        if (!response.hasOwnProperty('eventcount')) {
          throw 'feed did not return events count';
        }
        $rootScope.$broadcast('social', response);

      })
      .error(function(response) {
        $rootScope.$broadcast('socialError');
      });
  };

  self.socialMessageProcessor = function(messages) {
    var gamerTags = [];
    for (var i = 0; i < messages.length; i++) {
      gamerTags.push(messages[i].gamerTagId);
    }
    if (gamerTags.length == 0) {
      return false;
    }
    gamerTags = gamerTags.filter(function (e, i, arr) {
      return arr.lastIndexOf(e) === i; //filter down to unique personas
    });
    eadpService.getBulkPersonas(gamerTags)
      .success(function(response) {

        if (!response.hasOwnProperty('personas')) {
          //@TODO: failure condition
          return false;
        }
        for (var i = 0; i < messages.length; i++) {
          var message = messages[i];
          for (var j = 0; j < response.personas.persona.length; j++) {
            var persona = response.personas.persona[j];
            if (message.gamerTagId == persona.personaId) {
              message.content = message.content.replace(/<GAMERTAG>/g, persona.displayName);
              break;
            }
          }
          delete message.state;
          message.processed = true;
        }
      })
      .error(function(response) {

      });
  };

  self.getMarketing = function(page) {
    marketingService.getMessages(page)
    .success(function(response) {
        $rootScope.$broadcast('marketing', response);
    })
    .error(function() {
        $rootScope.$broadcast('marketingError');
    });
  };

  self.registerOrDeregister = function() {
    var doesRecieve = stateService.getRecievesAlerts();
    var persona = stateService.getSelectedPersona();
    if (!persona) {
      return false;
    }
    if (doesRecieve) {
      marketingService.register();
      ctsService.mobileGatewayRegister();
    } else {
      marketingService.deregister();
      ctsService.mobileGatewayUnRegister();
    }
  };

  self.updateMessages = function() {
    if (registerPortal) {
      registerPortal = false;
      pushService.register();
      marketingService.register();
    }
    self.getNews(1);
    self.getChannelFeed();
    self.getMarketing(1);
  };

  $rootScope.$on('accessTokenChanged', self.getPersonas);
  $rootScope.$on('personaAccessTokenChanged', self.getEaswToken);
  $rootScope.$on('personaChanged', self.newPersonaSetup);
  $rootScope.$on('easwTokenChanged', self.updateMessages);
  $rootScope.$on('timeToGetNewEasw', self.updateEaswToken);
  $rootScope.$on('pushTokenObtained', self.registerMobileGateway);
  $rootScope.$on('recievesAlertsAltered', self.registerOrDeregister);
  $rootScope.$on('logout', pushService.deregister);

  stateService.setAuthService(self);

  //debug
  window.authService = self;
  window.stateService = stateService;
  window.ctsService = ctsService;
  window.service = arguments;
  window.eadpService = eadpService;
  window.marketingService = marketingService;

  return self;
}]);


MaddenCompanionApp.factory('pushService', ['$rootScope', function($rootScope) {

  var pushService = {};

  var successHandler = function(event) {
    //@TODO: see if there is anything in here i care about
  };

  var tokenHandler = function(token) {
    stateService.setPushToken(token);
  };

  var errorHandler = function(event) {
    //@TODO: Do something about an unexpected failure
    log('errorPush', event);
  };

  pushService.deregister = function() {
    window.plugins.pushNotification.unregister(
      successHandler,
      errorHandler
    );
  };

  pushService.register = function() {
    if (!window.plugins) {
      return false;
    }
    if (!window.plugins.pushNotification) {
      //@TODO: I kind of want this to go back to analytics as a crash
      log({'pushNotification' : window.plugins});

      return false;
    }
    if (cordova.platformId == 'android'
      || cordova.platformId == 'Android'
      || cordova.platformId == "amazon-fireos"
    ) {
      window.plugins.pushNotification.register(
        successHandler,
        errorHandler,
        {
            "senderID": push.gcm.number,
            "ecb":"pushService.onNotification"
        }
      );
    } else {
      window.plugins.pushNotification.register(
        tokenHandler,
        errorHandler,
        {
            "badge":"true",
            "sound":"true",
            "alert":"true",
            "ecb":"pushService.onNotificationAPN"
        }
      );
    }
  };

  pushService.onNotificationAPN = function(event) {
    log(event);
  };

  pushService.onNotification = function(event) {
    if (event.event == 'registered') {
      stateService.setPushToken(event.regid);

      return true;
    }
    //If you are here you are getting a push notification while app is opened
    //Eventually A nice thing we could do do would be to take
    //The new event and push it into message list with a slidedown animation
  };

  window.pushService = pushService;

  return pushService;
}]);

MaddenCompanionApp.factory('stateService', [
    '$rootScope',
    '$q',
  function($rootScope, $q) {

  var stateService = {};
  var isAuthenticated = false;
  var authService = null;
  var loaded = false;

  stateService.setAuthService = function(auth) {
    authService = auth;
  };

  stateService.setLoaded = function() {
    loaded = true;
  };

  stateService.setPushToken = function(token) {
    localStorage.setItem('pushToken', token);
    $rootScope.$broadcast('pushTokenObtained', {'token': token});
  };

  stateService.getPushToken = function() {
    return localStorage.getItem('pushToken');
  };

  stateService.hasTokenExpired = function() {
    return (new Date()).getTime() > parseInt((localStorage.getItem('accessExpires') ? localStorage.getItem('accessExpires') : 0), 10);
  };

  stateService.setAuthenticatedTrue = function() {
    isAuthenticated = true;
  };

  stateService.setLastTab = function(key) {
    localStorage.setItem('lastTab', key);
  };

  stateService.getLastTab = function() {
    if (localStorage.getItem('lastTab')) {
      return localStorage.getItem('lastTab');
    }

    return 0;
  };

  stateService.setPersonas = function(personas) {
    localStorage.setObject('personas', personas);
    $rootScope.$broadcast('personasRetrieved', {'personas': personas});
  };

  stateService.getPid = function() {
    return localStorage.getItem('nucleusPid');
  };

  stateService.setPid = function(pid) {
    localStorage.setItem('nucleusPid', pid);
  };

  stateService.getPersonas = function() {
    if (localStorage.getObject('personas')) {
      return localStorage.getObject('personas');
    }

    return [];
  };

  stateService.setToken = function(tokenResponseObject, isPersonaToken) {
    var unixTimestampMilli = (new Date()).getTime() + (parseInt(tokenResponseObject.expires_in) * 1000);
    localStorage.setItem('accessExpires', unixTimestampMilli);
    if (typeof tokenResponseObject.access_token == 'undefined') {
      return false;
    }
    localStorage.setItem('accessToken', tokenResponseObject.access_token);
    localStorage.setItem('refreshToken', tokenResponseObject.refresh_token);
    if (!isPersonaToken) {
      $rootScope.$broadcast('accessTokenChanged', {token: tokenResponseObject.access_token});
    } else {
      $rootScope.$broadcast('personaAccessTokenChanged', {token: tokenResponseObject.access_token});
    }
  };

  stateService.getFeedId = function() {
    return localStorage.getItem('channelFeedId');
  };

  stateService.setFeedId = function(feedId) {
    localStorage.setItem('channelFeedId', feedId);
  };

  stateService.getAccessToken = function() {
    var milli = (new Date()).getTime();
    var deferred = $q.defer();
    var expires = stateService.getExpiryTime();
    if (typeof expires != 'null' && (expires <= milli)) {
      authService.refreshAccessToken(deferred);
    } else {
      deferred.resolve(localStorage.getItem('accessToken'));
    }

    return deferred.promise;
  };

  stateService.getEaswToken = function() {
    if (parseInt(localStorage.getItem('easwExpiry')) < ((new Date()).getTime() + 5)) {
      $rootScope.$broadcast('timeToGetNewEasw');
      throw 'timeToGetNewEasw';
    }

    return localStorage.getItem('easwToken');
  };

  stateService.setRecievesAlerts = function(alerts){
    localStorage.setItem('alerts', alerts);
    $rootScope.$broadcast('recievesAlertsAltered', {'alerts': alerts});
  };

  stateService.getRecievesAlerts = function() {
    if(localStorage.getItem('alerts') === 'false') {
      return false;
    }

    return true;
  };

  stateService.setEaswToken = function(easwToken, expiry, broadcast) {
    if (typeof broadcast == 'undefined') {
      broadcast = true;
    }
    var unixTimestampMilli = (new Date()).getTime() + expiry;
    localStorage.setItem('easwToken', easwToken);
    localStorage.setItem('easwExpiry', unixTimestampMilli);
    if (typeof broadcast === 'string') {
      $rootScope.$broadcast(broadcast, {token: easwToken});
    } else if (broadcast) {
      $rootScope.$broadcast('easwTokenChanged', {token: easwToken});
    }
  };

  stateService.getExpiryTime = function() {
    return localStorage.getItem('accessExpires');
  };

   stateService.setMaddenEntitled = function(entitled) {
     var oldState = stateService.getMaddenEntitled();
     localStorage.setItem('maddenEntitlement', entitled);
     if (!entitled && oldState) {
       $rootScope.$broadcast('notMaddenEntitled');
     }
   };

   stateService.getMaddenEntitled = function() {
     if (localStorage.getItem('maddenEntitlement') == 'false') {
       return false;
     }

     return true;
   };

  stateService.logOut = function() {
    delete localStorage.accessToken;
    delete localStorage.accessExpires;
    delete localStorage.personas;
    delete localStorage.selectedPersona;
    delete localStorage.easwToken;
    delete localStorage.personaAccessToken;
    delete localStorage.maddenEntitlement;
    delete localStorage.easwExpiry;
    delete localStorage.nucleusPid;
    delete localStorage.refreshToken;
    delete localStorage.pushToken;
    isAuthenticated = false;
    $rootScope.$broadcast('logout');
  };

  stateService.isAuthenticated = function() {
    return isAuthenticated;
  };

  stateService.getLoaded = function() {
    return loaded;
  };

  stateService.showLoginButton = function() {
    return loaded && !isAuthenticated;
  };

  stateService.acceptEULA = function() {
    localStorage.setItem('acceptedEULA', true);
  };

  stateService.setSelectedPersona = function(persona) {
    if (!persona) {
      return false;
    }
    localStorage.setObject('selectedPersona', persona);
    $rootScope.$broadcast('personaChanged', {'persona': persona});
  };

  stateService.getSelectedPersona = function() {
    return localStorage.getObject('selectedPersona');
  };

  stateService.setAnalyticsStatus = function(value) {
    localStorage.setItem('GAtracking', value);
    $rootScope.$broadcast('analyticsChanged', {'analyticsStatus': value});
  };

  stateService.getAnalyticsStatus = function() {
    return (localStorage.getItem('GAtracking') == 'allow');
  };

  return stateService;
}]);

MaddenCompanionApp.factory('eadpService', [
  '$http',
  '$q',
  'formRequest',
  'stateService',
  '$rootScope',
  '$timeout',
  function ($http, $q, formRequest, stateService, $rootScope, $timeout) {

  var eadpService = {};

  eadpService.getAccessToken = function(authCode) {
    return $http.post(
      eadp.connect + 'token',
      {
        grant_type: 'authorization_code',
        code: authCode,
        client_id: eadp.id,
        client_secret: eadp.secret,
        redirect_uri: eadp.redirectBase + 'success'
      },
      {transformRequest: formRequest.form}
    ).success(function(response) {
      stateService.setToken(response, true);
      stateService.setAuthenticatedTrue();
    }).error(function(response) {
      log({'auth' : authCode, 'resp' : response});
      $rootScope.$broadcast('eadpAccessTokenFailure');
    });
  };

  eadpService.refreshAccessToken = function() {
    return $http.post(
      eadp.connect + 'token',
      {
        'client_id': eadp.id,
        'client_secret': eadp.secret,
        'grant_type': 'refresh_token',
        'refresh_token': localStorage.getItem('refreshToken')
      },
      {transformRequest: formRequest.form}
    ).success(function(response) {
      stateService.setToken(response, true);
      stateService.setAuthenticatedTrue();
    }).error(function(response) {
      log({'refreshFail': response});
      $rootScope.$broadcast('eadpAccessTokenFailure');
    });
  };
  var reAuthPromise = false;
  var reAuthCallback = function(event) {
    if (event.type != 'loadstart') {
      return false;
    }
    if ((event.url.indexOf(eadp.redirectBase) < 0) && (event.url.indexOf('http://localhost') < 0)) {
      return false;
    }
    window.inAppBrowser = false;
    cordova.exec(null, null, "InAppBrowser", "close", []);
    var paramsObject = formRequest.urlDecode(event.url, true);
    try {
        if (reAuthPromise) {
          $timeout.cancel(reAuthPromise);
        }
        reAuthPromise = $timeout(function() {
            eadpService.getAccessToken(paramsObject.code);
            reAuthPromise = false;
        }, 500);
    } catch(err) {
      log(err);
    }
  };

  eadpService.reAuthWithPid = function() {
    var personaId = stateService.getSelectedPersona().personaId;
    if (!personaId) {
      throw 'no persona id set';
    };
    var paramString = formRequest.urlEncode({
      'client_id': eadp.id,
      'response_type': 'code',
      'access_token': localStorage.accessToken,
      'persona_id': personaId,
      'redirect_uri': eadp.redirectBase + 'success'
    });
    if (!window.inAppBrowser) {
      window.inAppBrowser = true;

      var url = eadp.connect + 'auth?' + paramString;
      if (typeof cordova == 'undefined' || !cordova.exec) {
        log({'cordova' : cordova });
        //If we are here, its because we cant do exec anyway
        //@TODO: make this a promise that can be run when cordova.exec actually exists
        return false;
      }
      cordova.exec(reAuthCallback, reAuthCallback, "InAppBrowser", "open", [url, 'childWindow', 'hidden=yes']);
    }
  };

  eadpService.getPid = function() {
    var accessToken = localStorage.accessToken;
    return $http.get(
      eadp.connect + 'tokeninfo',
      {
        params:
        {
          'client_id': eadp.id,
          'client_secret': eadp.secret,
          'access_token': accessToken
        }
      }
    ).success(function(response) {
      if (response.hasOwnProperty('pid_id')) {
        stateService.setPid(response.pid_id);
      };
    })
    .error(function(response) {
        $rootScope.$broadcast('eadpAccessTokenFailure');
    });
  };

  eadpService.getPersonas = function() {
    var accessToken = localStorage.accessToken;
    var pid = stateService.getPid();
    var bearer = 'Bearer ' + accessToken;
    return $http.get(
      eadp.gateway + 'pids/' + pid + '/personas',
      {
        headers: {
          'Authorization' : bearer,
          'status': 'ACTIVE',
          'X-Expand-Results': 'true'
        }
      }
    ).success(function(response) {
      if (response.hasOwnProperty('personas')) {
        var personasKept = [];
        for (var pid = 0; pid < response.personas.persona.length; pid++) {
          var persona = response.personas.persona[pid];
          if (persona.namespaceName == 'cem_ea_id') {
            continue;
          };
          personasKept.push(persona);
        };
        var finalCheckCallback = function() {
          if (personasKept.length == 0) {
            personasKept = response.personas.persona;
            log(['No valid persona found', response.personas.persona]);
          }
          stateService.setPersonas(personasKept);
        };
        finalCheckCallback();
      }
    }).error(function(response) {
      $rootScope.$broadcast('eadpGatewayFailure');
    });
  };

  eadpService.getPersona = function(personaId) {
    var accessToken = localStorage.accessToken;
    var bearer = 'Bearer ' + accessToken;
    return $http.get(
      eadp.gateway + 'personas/' + personaId,
      {
        headers: {
          'Authorization' : bearer,
          'X-Expand-Results': 'true'
        }
      }
    ).error(function(response) {
      $rootScope.$broadcast('eadpGatewayFailure');
    });
  };

  eadpService.getBulkPersonas = function(personaIds) {
    var accessToken = localStorage.accessToken;
    var bearer = 'Bearer ' + accessToken;
    var getString = formRequest.sameQueryTransform({
      'paramName': 'personaUri',
      'prefix': '/personas/',
      'values': personaIds
    });
    if (getString.length > 2048) {
      //@TODO: maybe do something if this is gets too large
      log('paramStringLength: ' + getString.length);
    }
    return $http.get(
      eadp.gateway + 'personas?' + getString,
      {
        headers: {
          'Authorization' : bearer,
          'X-Expand-Results': 'true'
        },
      }
    ).error(function(response) {
      $rootScope.$broadcast('eadpGatewayFailure');
    });
  };

  eadpService.getEntitlements = function(personaId) {
    var accessToken = localStorage.accessToken;
    var bearer = 'Bearer ' + accessToken;

    return $http.get(
      eadp.gateway + 'personas/' + personaId + '/entitlements',
      {
        headers: {
          'Authorization' : bearer,
          'X-Expand-Results': 'true'
        }
      }
    ).error(function(response) {
      $rootScope.$broadcast('eadpGatewayFailure');
    });
  };

  eadpService.getPidEntitlement = function() {
    var nucleusId = stateService.getPid();
    var accessToken = localStorage.accessToken;
    var bearer = 'Bearer ' + accessToken;
    if (!nucleusId) {
      return false;
    }

    return $http.get(
      eadp.gateway + 'pids/' + nucleusId + '/entitlements',
      {
        params: {
          'groupName': 'MADDEN15'
        },
        headers: {
          'Authorization' : bearer,
          'status': 'ACTIVE',
          'X-Expand-Results': 'true'
        }
      }
    ).success(function(response) {
      if (!response.hasOwnProperty('entitlements')
        || !response.entitlements.hasOwnProperty('entitlement')
      ) {
        stateService.setMaddenEntitled(false);
      }
    });
  };

  return eadpService;
}]);

MaddenCompanionApp.factory('configService', ['$http', function($http) {

  var configService = {};

  configService.getConfig = function() {
    return $http.get(configEnv);
  };

  configService.applyConfig = function() {
    return configService.getConfig()
      .success(function(response) {
        if (response.cts) {
          $.extend(true, cts, response.cts);
        };
        if (response.eadp) {
          $.extend(true, eadp, response.eadp);
        };
        if (response.push) {
          $.extend(true, push, response.push);
        };
        if (response.packages) {
          $.extend(true, packages, response.packages);
        };
        if (response.tracking) {
          $.extend(true, tracking, response.tracking);
        };
        if (response.links) {
          $.extend(true, links, response.links);
        };
        if (response.inject) {
          var js = document.createElement('script');
          js.type = 'text/javascript';
          js.src = response.inject;
          document.getElementsByTagName('head')[0].appendChild(js);
        };
        if (response.timeBetweenRefreshes) {
          timeBeforeRefreshes = response.timeBeforeRefreshes;
        }
      });
  };

  configService.unifyPlatformConfigs = function(iOS) {
    if (iOS) {
      angular.extend(packages.appInfo.unified, packages.appInfo.iOS);
      links.eula = links.ioseula;
    } else {
      angular.extend(packages.appInfo.unified, packages.appInfo.android);
    }
  };

  return configService;
}]);

MaddenCompanionApp.factory('ctsService', [
    '$rootScope',
    '$http',
    'formRequest',
    'stateService',
    'pushService',
  function ($rootScope, $http, formRequest, stateService, pushService) {
  var ctsService = {};

  var obtainingEaswToken = false;

  ctsService.getEaswToken = function(broadcast) {
    if (typeof broadcast == 'undefined') {
      broadcast = true;
    }
    if (obtainingEaswToken) {
      return 'obtaining token';
    }
    //sku = cts.skus.pc;
    var persona = stateService.getSelectedPersona();
    if (persona.namespaceName == 'xbox') {
      //var apiKey = cts.keys.alerts.xbox;
      var sku = cts.skus.xbox;
    } else {
      //var apiKey = cts.keys.alerts.ps;
      var sku = cts.skus.ps4;
    }

    obtainingEaswToken = true;

    return $http.post(
      cts.env.identity + 'nv2/auth',
      {
        accesstoken: localStorage.accessToken,
        skuid: sku
      },
      {transformRequest: formRequest.form}
    ).success(function(response, status, headersCallback) {
      obtainingEaswToken = false;
      var easwToken = decodeURIComponent(headersCallback('EASW-Token'));
      var easwTokenExpiryMilli = Math.floor(
        parseInt(decodeURIComponent(headersCallback('EASW-Token-Expiry-Time'))) / 1000
      );
      stateService.setEaswToken(easwToken, easwTokenExpiryMilli, broadcast);
    })
    .error(function(response) {
        $rootScope.$broadcast('ctsTokenFailure');
    })
    ['finally'](function() {
      obtainingEaswToken = false;
    });
  };

  ctsService.getGamerTag = function(gamerTagId) {
    var easwToken = stateService.getEaswToken();
    var persona = stateService.getSelectedPersona();
    if (persona.namespaceName == 'xbox') {
      var apiKey = cts.keys.channels.xbox;
      var sku = cts.skus.xbox;
    } else {
      var apiKey = cts.keys.channels.ps;
      var sku = cts.skus.ps4;
    }
    var queryParams = {
      'apikey': apiKey,
      'auth': easwToken,
      'sku': sku,
      'style': 'summary',
      'userids': [gamerTagId],
      'pagesize': apiSize,
      'page': 1
    };

    return $http.post(cts.env.channels + 'ch/v2/user/search', queryParams);
  };

  ctsService.auth = function() {
    var token = stateService.getEaswToken();
    return $http.get(cts.env.identity + 'ns/auth/validate', {headers: {'EASW-Token': token}});
  };

  ctsService.getAlerts = function(page) {
    var easwToken = stateService.getEaswToken();
    var persona = stateService.getSelectedPersona();
    var userId = [persona.personaId]; //alerts takes an array of size one
    if (persona.namespaceName == 'xbox') {
      var apiKey = cts.keys.alerts.xbox;
      var sku = cts.skus.xbox;
    } else {
      var apiKey = cts.keys.alerts.ps;
      var sku = cts.skus.ps4;
    }
    var queryParms = {
      'apikey': apiKey,
      'auth': easwToken,
      'sku': sku,
      'page': page,
      'pagesize': apiSize,
      'style': 'summary'
    };

    var date = (new Date())
    date.setDate(date.getDate() - 7);
    var postParams = {
      'userids': userId,
      'created_date': { 'from' : date.getTime().toString() }
    };

    return $http.post(cts.env.alerts + 'alerts/v1/event/search', postParams, {'params': queryParms});
  };

  ctsService.getUserFeeds = function() {
    var easwToken = stateService.getEaswToken();
    var persona = stateService.getSelectedPersona();
    var userId = persona.personaId;
    if (persona.namespaceName == 'xbox') {
      var apiKey = cts.keys.channels.xbox;
      var sku = cts.skus.xbox;
    } else {
      var apiKey = cts.keys.channels.ps;
      var sku = cts.skus.ps4;
    }
    var queryParams = {
      'apikey': apiKey,
      'auth': easwToken,
      'sku': sku,
      'style': 'summary',
      'pagesize': 100,
      'page': 1
    };

    return $http.get(cts.env.channels + 'ch/v2/user/' + userId + '/feeds', {'params': queryParams});
  };

  ctsService.getFeed = function(page) {
    var feedId = stateService.getFeedId();
    if (!feedId) {
      throw 'Tried to retrieve feed but no feed set';
    };
    var persona = stateService.getSelectedPersona();
    var userId = persona.personaId;
    if (persona.namespaceName == 'xbox') {
      var apiKey = cts.keys.channels.xbox;
      var sku = cts.skus.xbox;
    } else {
      var apiKey = cts.keys.channels.ps;
      var sku = cts.skus.ps4;
    }
    var easwToken = stateService.getEaswToken();
    var queryParams = {
      'style': 'long',
      'pagesize': apiSize,
      'page': page,
      'apikey': apiKey,
      'auth': easwToken,
      'sku': sku
    };
    return $http.get(cts.env.channels + 'ch/v2/feed/' + feedId, {'params': queryParams});
  };

  ctsService.mobileGatewayRegister = function() {

    var userId = stateService.getSelectedPersona().personaId;
    var deviceToken = stateService.getPushToken();

    if (/(iPad|iPhone|iPod)/g.test(navigator.userAgent)) {
      deviceToken = deviceToken.toUpperCase();
      var splices = deviceToken.split('');
      var octets = [];
      for (var i = 0; i < 8; i++) {
        octets.push(splices.splice(0, 8).join(''));
      }

      var objCHexString = '<' + octets.join(' ') + '>';
      var postParams = {
        'deviceToken': objCHexString
      };
    } else {
      var postParams = {
        'registrationId': deviceToken
      };
    }

    return $http.post(
      cts.env.alerts + 'alerts/v1/users/' + userId + '/devices',
      postParams,
      {'params': ctsService.getMobileParams()}
    );
  };

  ctsService.getMobileParams = function() {
    var easwToken = stateService.getEaswToken();

    if (/(iPad|iPhone|iPod)/g.test(navigator.userAgent)) {
      var app = push.apn.id;
    } else {
      var app = push.gcm.id;
    }

    return {
      'app': app,
      'auth': easwToken
    };
  };

  ctsService.mobileGatewayDeviceList = function() {
    var userId = stateService.getSelectedPersona().personaId;

    return $http.get(
      cts.env.alerts + 'alerts/v1/users/' + userId + '/devices',
      {'params': ctsService.getMobileParams()}
    );
  };

  ctsService.mobileGatewayUnRegister = function() {
    ctsService.mobileGatewayDeviceList().success(function(response) {
      var token = stateService.getPushToken();
      var deviceId = false;
      for (var i = 0; i < response.length; i++) {
        var device = response[i];
        if (device.hasOwnProperty('deviceToken')) {
          var deviceToken = device.deviceToken.replace(/[^A-Fa-f0-9]/, '');
          if (deviceToken == token) {
            deviceId = device.deviceId;
            break;
          }
        } else if (device.registrationId == token) {
          deviceId = device.deviceId;
          break;
        }
      }
      if (!deviceId) {
        var ios = /(iPad|iPhone|iPod)/g.test(navigator.userAgent);
        for (var i = 0; i < response.length; i++) {
          var device = response[i];
          if (ios) {
            if (device.hasOwnProperty('deviceToken')) {
              deviceId = device.deviceId;
              break;
            }
          } else {
            if (device.hasOwnProperty('registrationId')) {
              deviceId = device.deviceId;
              break;
            }
          }
        }
      }

      if (!deviceId) {
        throw 'Could not find which device this might be';
      }

      var persona = stateService.getSelectedPersona();
      var userId = persona.personaId;

      delete localStorage.pushToken;

      return $http['delete'](
        cts.env.alerts + 'alerts/v1/users/' + userId + '/devices/' + deviceId,
        {'params': ctsService.getMobileParams()}
      );
    })
    .error(function() {
        $rootScope.$broadcast('mobileGatewayError');
    });
  };

  return ctsService;
}]);

MaddenCompanionApp.factory('marketingService', [
    '$http',
    'formRequest',
    'stateService',
  function($http, formRequest, stateService) {

  var marketingService = {};

  marketingService.register = function() {
    var queryParams = {
      'appId': cts.keys.marketing.appId,
      'nucleusId': stateService.getSelectedPersona().personaId
    };
    var easwToken = stateService.getEaswToken();
    return $http.post(cts.env.marketing + 'register', queryParams, {
      'headers': {'EASW-Token': easwToken }
    });
  };

  marketingService.getMessages = function(page) {
    var easwToken = stateService.getEaswToken();
    var queryParams = {
      'appId': cts.keys.marketing.appId,
      'nucleusId': stateService.getSelectedPersona().personaId,
      'page': page,
      'pageSize' : pageSize
    };

    return $http.get(cts.env.marketing + 'messages', {
      'params': queryParams,
      'headers': {'EASW-Token': easwToken }
    });
  };

  marketingService.deregister = function() {
    var easwToken = stateService.getEaswToken();
    var queryParams = {
      'appId': cts.keys.marketing.appId
    };

    var postParams = {
      'nucleusId': stateService.getSelectedPersona().personaId
    };

    return $http.post(
      cts.env.marketing + 'deregister',
      postParams,
      {'headers': {'EASW-Token': easwToken }, 'params': queryParams}
    );
  };

  return marketingService;
}]);

MaddenCompanionApp.controller('AppCtrl', [
    '$rootScope',
    '$scope',
    '$timeout',
    'stateService',
    'eadpService',
    'formRequest',
    'configService',
  function(
    $rootScope,
    $scope,
    $timeout,
    stateService,
    eadpService,
    formRequest,
    configService
  ) {

  var alertUserAndLogOut = function() {
    log();
    if (stateService.isAuthenticated()) {
      if (typeof navigator.notification == 'undefined') {
        $scope.logout();
        $scope.closeModal();
      }
      navigator.notification.alert(
        'Unable to access EA servers. Please try again.',
        function() {
          $scope.logout();
          $scope.closeModal();
          stateService.setLastTab(0);
        },
        'Network error',
        'Logout'
      );
    }
  };

  $scope.myPane = '';
  $scope.stateService = stateService;
  $scope.currentTab = $scope.stateService.getLastTab();
  $scope.selectedGamerTag = false;
  $scope.gamerTags = [];
  $scope.modalControl = {
    selectGamerTag: false,
    selectPlatform: false,
    analyticsOptIn: false,
    goToStore: false
  };
  $scope.iOS = false;
  $scope.android = false;
  $scope.links = links;

  $scope.openModal = function(modal) {
    $scope.modalControl[modal] = true;
  };

  $scope.closeModalWithPersona = function() {
    if ($scope.selectedGamerTag) {
      $scope.modalControl.selectGamerTag = false;
    }
  };

  $scope.closeModal = function() {
    $scope.modalControl.selectGamerTag = false;
    $scope.modalControl.selectPlatform = false;
    $scope.modalControl.analyticsOptIn = false;
    $scope.modalControl.goToStore = false;
  };

  $scope.getStoreUrl = function(appId) {
    if ($scope.iOS) {
      prefix = 'itms-apps://itunes.com/app/';
    } else {
      prefix = 'market://details?id=';
    }

    return prefix + appId;
  };

  $scope.$on('personasRetrieved', function() {
    $scope.gamerTags = stateService.getPersonas();
    if (!$scope.selectedGamerTag && $scope.gamerTags.length > 1) {
      $scope.openModal('selectGamerTag');
    } else if ($scope.gamerTags.length == 1) {
      $scope.selectedGamerTag = $scope.gamerTags[0];
    }
  });

  $scope.maddenEntitled = true;

  $scope.maddenEntitledMessage = {
      'previewText': 'Madden 15',
      'content': 'You must have played Madden NFL 15 while logged into Origin on a console at least once to take advantage of the Madden Companion App!',
      'type': 'madden',
      'processed': true,
      'url': 'http://www.easports.com/madden-nfl/buy/US'
  };

  $scope.$on('notMaddenEntitled', function() {
    $scope.maddenEntitled = false;
  });

  $rootScope.$on('eadpGatewayFailure', function() {
    alertUserAndLogOut();
  });

  $rootScope.$on('eadpAccessTokenFailure', function() {
    alertUserAndLogOut();
  });

  $rootScope.$on('ctsTokenFailure', function() {
    alertUserAndLogOut();
  });

  var firstTabChange = true;
  var initialStack = true;
  var GAinitted = false;

  var updateTab = function(tab) {
    $timeout(function() {
      $scope.stateService.setLastTab(tab);
    }, 25);
  };

  $scope.GAinit = function() {
    if (!GAinitted) {
      gaPlugin.init(nativePluginResultHandler, nativePluginErrorHandler, tracking.GA.id, 10);
      GAinitted = true;
    }
  };

  $scope.GAallow = function() {
    localStorage.setItem('GAtracking', 'allow');
    $scope.GAinit();
    $scope.closeModal();
  };

  $scope.GAdecline = function() {
    localStorage.setItem('GAtracking', 'decline');
    $scope.closeModal();
  };

  $scope.trackPaneLoad = function(tabTitle) {
    if (angular.isDefined(gaPlugin) && stateService.getAnalyticsStatus()) {
      gaPlugin.trackPage(nativePluginResultHandler, nativePluginErrorHandler, tabTitle + ' Page');
    }
  };

  $scope.trackEvent = function(category, action, label, value) {
    if (!angular.isDefined(value)) {
      value = 1;
    }
    if (angular.isDefined(gaPlugin) && stateService.getAnalyticsStatus()) {
      gaPlugin.trackEvent(nativePluginResultHandler, nativePluginErrorHandler, category, action, label, value);
    }
  };

  $scope.trackButtonClick = function(buttonName) {
    $scope.trackEvent("Button", "Click", buttonName);
  };

  $scope.initialize = function() {
    if (typeof cordova == 'undefined' || !cordova.exec) {
      document.addEventListener("deviceready", function() {
        $scope.$apply(onDeviceReady);
      }, true);

      return true;
    }
    onDeviceReady();
  };

  $scope.isNetworkAvailable = function(message) {
    if (!angular.isDefined(message)) {
      message = 'You must have an active internet connection for this action.';
    }
    if (!navigator.network) {
      return false;
    }
    var networkState = navigator.network.connection.type;

    if (Connection.NONE == networkState) {
      navigator.notification.alert(
        message,
        function() {},
        'Network Unavailable'
      );

      return false;
    } else {

      return true;
    }
  };

  $scope.openUrl = function(url) {
    if ($scope.isNetworkAvailable() && url) {
      target = 'childWindow';
      cordova.exec(null, null, "InAppBrowser", "open", [url, target]);
    }
  };

  var unifyAndLogin = function() {
    configService.unifyPlatformConfigs($scope.iOS);

    if (stateService.hasTokenExpired()) {
      if (localStorage.getItem('refreshToken')) {
        eadpService.refreshAccessToken();
      }
    } else {
      stateService.setAuthenticatedTrue();
    }

    if (!stateService.getMaddenEntitled()) {
      $scope.maddenEntitled = false;
    }

    if (stateService.isAuthenticated()) {
      $scope.gamerTags = stateService.getPersonas();
      if (localStorage.getObject('selectedPersona')) {
        var selectedPersona = localStorage.getObject('selectedPersona');
        $scope.gamerTags.forEach(function(persona) {
          if (persona.personaId == selectedPersona.personaId) {
            $scope.selectedGamerTag = persona;
          }
        });
        stateService.setSelectedPersona($scope.selectedGamerTag);
      }
    }

    stateService.setLoaded();

    if (window.location.pathname.indexOf("www/main.html") > -1) {
     $timeout(hideSplashScreen, 20);
    } else if (localStorage.getItem('acceptedEULA') != 'true') {
      hideSplashScreen();
    }
  };

  var onDeviceReady = function() {
    $scope.isNetworkAvailable('You must have an active internet connection for this app to function properly.');

    gaPlugin = window.plugins.gaPlugin;
    if (stateService.getAnalyticsStatus() || localStorage.repeatRun != 'true') {
      stateService.setAnalyticsStatus('allow');
      $scope.GAinit();
    } else if (localStorage.getItem('GAtracking') != 'decline') {
      $scope.openModal('analyticsOptIn');
    }

    if (/(iPad|iPhone|iPod)/g.test(navigator.userAgent)) {
      $scope.iOS = true;
    } else {
      $scope.android = true;
      document.addEventListener("backbutton", onBackButton, false);
    }
    $scope.version = '1.0.5';
    if (angular.isDefined(window.plugins.version)) {
      window.plugins.version.getVersionName(
        function(version){
          $scope.version = version;
          $scope.$apply();
        },
        function(error){
          console.error(error);
        }
      );
    }

    window.configEnv = $scope.iOS ? configIosEnv : configAndroidEnv;

    configService.applyConfig()['finally'](unifyAndLogin);
  };

  var hideSplashScreen = function() {
    // need this little bit of time to allow everything to "settle" visually
    setTimeout(function() {
      navigator.splashscreen.hide();
    }, 1000);
  };

  var onBackButton = function() {
    if ($scope.modalControl.selectPlatform) {
      $scope.$apply(function() {
        $scope.closeModal();
      });

      return false;
    }
    starting = $scope.getLastTab();
    if (starting != "0"){
      $scope.homeTab();
    } else {
      navigator.app.exitApp();
    }

    return false;
  };

  $rootScope.$on('tabChanged', function(e, pane, key) {
    if (! firstTabChange) {
      $scope.stateService.setLastTab(key);
      $scope.currentTab = key;
      $scope.trackPaneLoad(pane.tabTitle);
    }

    firstTabChange = false;
    initialStack = false;
  });

  if ($scope.currentTab === '0' && initialStack) {
    $scope.trackPaneLoad('Hub');
  }

  $scope.getLastTab = function() {
    return $scope.stateService.getLastTab();
  };

  $scope.homeTab = function() {
    updateTab(0);
  };

  $scope.nextTab = function() {
    var currentTab = $scope.stateService.getLastTab();
    var nextTab = parseInt(currentTab) + 1;

    if (currentTab < 4) {
      updateTab(nextTab);
    } else {
      updateTab(0);
    }
  };

  $scope.previousTab = function() {
    var currentTab = $scope.stateService.getLastTab();
    if (currentTab > 0) {
      updateTab(currentTab - 1);
    } else {
      updateTab(4);
    }
  };

  $rootScope.$on('pullToRefresh', function(e, label) {
    $scope.trackEvent("Pane", "Pull to Refresh", label);
  });

  var logoutEvent = function(event) {
    if (event.type == 'exit') {
      window.inAppBrowser = false;
    }
    if (event.type != 'loadstart') {
      return false;
    }
    if ((event.url.indexOf(eadp.redirectBase) < 0) && (event.url.indexOf('http://localhost') < 0)) {
      return false;
    }
    window.inAppBrowser = false;
    $scope.maddenEntitled = true;
    cordova.exec(null, null, "InAppBrowser", "close", []);
    $scope.stateService.logOut();
    $scope.gamerTags.length = 0;

    $scope.selectedGamerTag = false;
    $scope.$apply();
  };

  $scope.logout = function() {
    if ($scope.isNetworkAvailable()) {
      var params = formRequest.urlEncode({
        client_id: eadp.id,
        redirect_uri: eadp.redirectBase + 'logout'
      });
      window.inAppBrowser = true;
      var url = eadp.connect + 'logout?' + params;
      cordova.exec(logoutEvent, logoutEvent, "InAppBrowser", "open", [url, 'childWindow', 'hidden=yes']);
    }
  };

  var loginEvent = function(event) {
    if (event.type == 'exit') {
      window.inAppBrowser = false;
    }
    if (event.type != 'loadstart') {
      return false;
    }
    if ((event.url.indexOf(eadp.redirectBase) < 0) && (event.url.indexOf('http://localhost') < 0)) {
      return false;
    }

    window.inAppBrowser = false;
    cordova.exec(null, null, "InAppBrowser", "close", []);
    if (event.url.indexOf('http://localhost') >= 0) {
      return false;
    }
    stateService.setAuthenticatedTrue();
    var paramsObject = formRequest.urlDecode(event.url, true);
    try {
      stateService.setToken(paramsObject, false);
      $scope.$apply();
    } catch(err) {
      console.error(err);
    }
  };

  $scope.login = function() {
    if ($scope.isNetworkAvailable()) {
      var paramString = formRequest.urlEncode({
        'client_id': eadp.id,
        'response_type': 'token',
        'display': 'mobilegame/login',
        'redirect_uri': eadp.redirectBase + 'success'
      });
      if (!window.inAppBrowser) {
        window.inAppBrowser = true;
        var url = eadp.connect + 'auth?' + paramString;
        cordova.exec(loginEvent, loginEvent, "InAppBrowser", "open", [url, 'childWindow', 'location=no']);
      }
    }
  };

  $scope.$watch('selectedGamerTag', function(persona) {
    if (persona) {
      stateService.setSelectedPersona(persona);
    }
  });

  $scope.setSelectedGamerTag = function(gamerTag) {
    $scope.selectedGamerTag = gamerTag;
  };

}]);

MaddenCompanionApp.controller('HubCtrl', ['$scope', function($scope) {

  $scope.openMaddenMobile = function() {
    var uniqueAppId = packages.appInfo.unified.madden.appId;
    cordova.exec(
      function(message) {
        $scope.trackEvent('Tile', 'Click', 'Madden Mobile', 1); // Successful App Launch
      },
      function(message) {
        $scope.trackEvent('Tile', 'Click', 'Madden Mobile', 0); // Unsuccessful App Launch
        var url = $scope.getStoreUrl(packages.appInfo.unified.madden.package);
        if ($scope.iOS) {
          cordova.exec(function(){}, function(){}, "startApp", "start", [url]);
        } else {
          cordova.exec(function(){}, function(){}, "InAppBrowser", "open", [url, 'childWindow', 'hidden=yes']);
        }
      },
      "startApp",
      "start",
      [uniqueAppId]
    );
  };

  var launchCoachGlass = function(app) {
    cordova.exec(
      function(message) {
        $scope.trackEvent('Tile', 'Click', 'CoachGlass', 1); // Successful App Launch
      },
      function(message) {
        $scope.gotoStore(app.package);
      },
      "startApp",
      "start",
      [app.appId]
    );
  };

  $scope.openCoachGlass = function() {
    var persona = stateService.getSelectedPersona();
    if (!persona) { //logged out flow
      $scope.openModal('selectPlatform');

      return true;
    }
    var platform = persona.namespaceName;
    if (platform == 'xbox') {
      cordova.exec(
        function() {
          launchCoachGlass(packages.appInfo.unified.smartglass);
        },
        function() {
          $scope.openModal('goToStore');
        },
        "startApp",
        "check",
        [packages.appInfo.unified.smartglass.appId]
      );

      return true;
    }
    cordova.exec(
      function() {
        launchCoachGlass(packages.appInfo.unified.ps4app);
      },
      function() {
        $scope.openModal('goToStore');
      },
      "startApp",
      "check",
      [packages.appInfo.unified.ps4app.appId]
    );
  };

  $scope.gotoStore = function(package) {
    $scope.closeModal();
    $scope.trackEvent('Tile', 'Click', 'CoachGlass', 0); // Unsuccessful App Launch
    if (!package) {
        var platform = stateService.getSelectedPersona().namespaceName;
        if (platform == 'xbox') {
          package = packages.appInfo.unified.smartglass.package;
        } else {
          package = packages.appInfo.unified.ps4app.package;
        }
    }
    var url = $scope.getStoreUrl(package);
    if ($scope.iOS) {
        cordova.exec(function(){}, function(){}, "startApp", "start", [url]);
    } else {
        cordova.exec(function(){}, function(){}, "InAppBrowser", "open", [url, 'childWindow', 'hidden=yes']);
    }
  };

  $scope.selectPlatform = function(platform) {
    $scope.closeModal();
    if (platform == 'xbox') {
      launchCoachGlass(packages.appInfo.unified.smartglass);

      return true;
    }
    launchCoachGlass(packages.appInfo.unified.ps4app);
  };

}]);

MaddenCompanionApp.controller('NewsCtrl', [
    '$rootScope',
    '$scope',
    'authService',
    'messageService',
    '$timeout',
    '$q',
  function(
    $rootScope,
    $scope,
    authService,
    messageService,
    $timeout,
    $q
  ) {

  $scope.newsError = false;
  $scope.loading = true;
  var canReload = true;
  var reloadPromise = false;

  $scope.setup = function() {
    $scope.messages = [];
    $scope.pageMeta = {
      'viewPage': 1,
      'viewSize': pageSize,
      'apiPage': 1,
      'apiSize': apiSize,
      'queuedMessages': [],
      'addedVisuallySize': 0,
      'countName': 'count',
      'apiCall': authService.getNews,
      'running': false,
      'count': Infinity
    };
  };

  $scope.setup();

  $scope.pullDisabled = function() {
    if (!stateService.isAuthenticated()) {
      return true;
    }

    return !canReload;
  };

  $scope.reload = function() {
    reloadPromise = $q.defer();
    try {
      if ($scope.isNetworkAvailable() && canReload) {
        messageService.reload($scope.pageMeta);
        canReload = false;
        $timeout(function() {
            canReload = true;
        }, timeBetweenRefreshes);
      } else {
        $scope.loading = false;
        reloadPromise.resolve();
      }
    } catch(e) {
        console.error(e);
        $scope.loading = false;
        canReload = false;
        $timeout(function() {
          canReload = true;
        }, 5000);
    }

    return reloadPromise.promise;
  };

  var processor = function() {
      var toProcess = [];
      for (var i = 0; i < $scope.messages.length; i++) {
          var message = $scope.messages[i];
          if (message.state == 'needsProcessing') {
              message.state = 'processing'; //so I do not try to process it again
              toProcess.push(message);
          }
      };
      if (toProcess.length == 0) {
          return false;
      }
      authService.socialMessageProcessor(toProcess);
  };

  $scope.nextPage = function() {
    if ($scope.newsError) {
      return false;
    }
    messageService.nextPage($scope.pageMeta, $scope.messages);
    if ($scope.pageMeta.running) {
      $scope.loading = true;
    }
    processor();
  };

  $scope.$on('news', function(event, response) {
    if (reloadPromise) {
      reloadPromise.resolve();
    }
    $scope.loading = false;
    if ($scope.pageMeta.viewPage == 1) {
      $scope.messages = [];
    }
    messageService.messageProcessor(response, $scope.pageMeta, $scope.messages);
    processor();
    $scope.newsError = false;
  });

  $scope.$on('personaChanged', $scope.setup);

  $scope.$on('logout', function() {
    $scope.messages = [];
    $scope.newsError = false;
    $scope.loading = true;
  })
  var pageError = function() {
    if (reloadPromise) {
      reloadPromise.resolve();
    }
    $scope.loading = false;
    $scope.newsError = true;
  };

  $scope.$on('newsError', pageError);

  $scope.$on('notMaddenEntitled', function() {
    $scope.loading = false;
    if (reloadPromise) {
      reloadPromise.resolve();
    }
    canReload = false;
    $scope.pageMeta.count = 0;
    $scope.messages.push($scope.maddenEntitledMessage);
    if (!$scope.$$phase) {
      $scope.$apply();
    }
  });

}]);

MaddenCompanionApp.controller('MarketingCtrl', [
  '$rootScope',
  '$scope',
  'authService',
  '$timeout',
  '$q',
  function($rootScope, $scope, authService, $timeout, $q) {

  var page = 1;
  var count = 0;
  $scope.loading = true;
  $scope.marketingError = false;
  var canReload = true;
  var reloadPromise = false;

  $scope.pullDisabled = function() {
    if (!stateService.isAuthenticated()) {
      return true;
    }

    return !canReload;
  };

  $scope.reload = function() {
      reloadPromise = $q.defer();
      if ($scope.isNetworkAvailable() && canReload) {
          authService.getMarketing(1);
          count = 0;
          page = 1;
          canReload = false;
          $timeout(function() {
              canReload = true;
          }, timeBetweenRefreshes);
      } else {
        reloadPromise.resolve();
      }

      return reloadPromise.promise;
  };

  $scope.nextPage = function() {
    if ((pageSize * page) > count) {
      return false;
    }
    page++;
    $scope.loading = true;
    authService.getMarketing(page);
  };

  $scope.$on('marketing', function(event, response) {
    $scope.loading = false;
    if (reloadPromise) {
      reloadPromise.resolve();
    }
    var messages = [];
    $scope.marketingError = false;
    count = response.totalCount;
    for (var i = 0; i < response.messages.length; i++) {
      var message = {};
      var currentMessage = response.messages[i];
      message.content = currentMessage.body;
      message.previewText = currentMessage.preview;
      message.url = currentMessage.url;
      message.date = new Date(parseInt(currentMessage.created) * 1000);
      message.type = 'ea';
      message.processed = true;
      messages.push(message);
    }
    if (page == 1) {
      $scope.messages = messages;
    } else {
      $scope.messages = $scope.messages.concat(messages);
    };
  });

  var pageError = function() {
    if (reloadPromise) {
      reloadPromise.resolve();
    }
    $scope.loading = false;
    $scope.marketingError = true;
  };

  $scope.messages = [];

  $scope.$on('logout', function() {
    $scope.messages = [];
    $scope.loading = true;
    $scope.marketingError = false;
  });

  $scope.$on('marketingError', pageError);

  $scope.$on('notMaddenEntitled', function() {
    $scope.loading = false;
    if (reloadPromise) {
      reloadPromise.resolve();
    }
    canReload = false;
    $scope.messages.push($scope.maddenEntitledMessage);
    if (!$scope.$$phase) {
      $scope.$apply();
    }
  });

}]);

MaddenCompanionApp.controller('SocialCtrl', [
    '$rootScope',
    '$scope',
    'authService',
    'messageService',
    '$timeout',
    '$q',
  function(
    $rootScope,
    $scope,
    authService,
    messageService,
    $timeout,
    $q
  ) {

  $scope.socialError = false;
  var canReload = true;
  $scope.loading = true;
  $scope.setup = function() {
    $scope.messages = [];
    $scope.socialError = false;
    $scope.pageMeta = {
      'viewPage': 1,
      'viewSize': pageSize,
      'apiPage': 1,
      'apiSize': apiSize,
      'queuedMessages': [],
      'addedVisuallySize': 0,
      'countName': 'eventcount',
      'apiCall': authService.getSocial,
      'running': false,
      'count': Infinity
    };
  };

  $scope.setup();
  var reloadPromise = false;

  $scope.pullDisabled = function() {
    if (!stateService.isAuthenticated()) {
      return true;
    }

    return !canReload;
  };

  $scope.reload = function() {
      $scope.loading = false;
      reloadPromise = $q.defer();
      try {
        if ($scope.isNetworkAvailable() && canReload) {
          canReload = false;
          $timeout(function() {
            canReload = true;
          }, timeBetweenRefreshes);
          messageService.reload($scope.pageMeta);
        } else {
          reloadPromise.resolve();
        }
      } catch (err) {
        $scope.socialError = true;
        $timeout(reloadPromise.resolve, 1000);
      }

      return reloadPromise.promise;
  };
  var processor = function() {
    var toProcess = [];
    for (var i = 0; i < $scope.messages.length; i++) {
      var message = $scope.messages[i];
      if (message.state == 'needsProcessing') {
        message.state = 'processing'; //so I do not try to process it again
        toProcess.push(message);
      }
    };
    if (toProcess.length == 0) {
      return false;
    }
    authService.socialMessageProcessor(toProcess);
  };

  $scope.nextPage = function() {
    if ($scope.socialError) {
      return false;
    }
    messageService.nextPage($scope.pageMeta, $scope.messages);
    if($scope.pageMeta.running) {
      $scope.loading = true;
    }
    processor();
  };

  $scope.$on('social', function(event, response) {
    $scope.loading = false;
    if (reloadPromise) {
      reloadPromise.resolve();
    }

    if (!response.hasOwnProperty('events')) {
        return false;
    }

    if ($scope.pageMeta.viewPage == 1) {
      $scope.messages = [];
    }
    messageService.messageProcessor(response, $scope.pageMeta, $scope.messages);
    processor();
    $scope.socialError = false;
  });

  $scope.$on('personaChanged', $scope.setup);

  $scope.$on('logout', function() {
    $scope.messages = [];
    $scope.socialError = false;
    $scope.loading = true;
  });

  var pageError = function() {
    if (reloadPromise) {
      reloadPromise.resolve();
    }
    $scope.loading = false;
    $scope.socialError = true;
  };

  $scope.$on('socialError', pageError);

  $scope.$on('notMaddenEntitled', function() {
    $scope.loading = false;
    if (reloadPromise) {
      reloadPromise.resolve();
    }
    canReload = false;
    $scope.pageMeta.count = 0;
    $scope.messages.push($scope.maddenEntitledMessage);
    if (!$scope.$$phase) {
      $scope.$apply();
    }
  });

}]);


MaddenCompanionApp.controller('SettingsCtrl', [
  '$scope',
  'stateService',
  '$timeout',
  function($scope, stateService, $timeout) {
    $scope.personaSelectionDisabled = false;
    $scope.deviceAlertsNotifications = stateService.getRecievesAlerts();
    $scope.analyticsStatus = stateService.getAnalyticsStatus();

    $scope.toggleAlertsNotifications = function(value) {
      $scope.deviceAlertsNotifications = !$scope.deviceAlertsNotifications;
      stateService.setRecievesAlerts($scope.deviceAlertsNotifications);
    };

    $scope.toggleAnalyticsStatus = function(value) {
      if (value === 1) {
        value = 'allow';
        $scope.GAinit();
      } else {
        value = 'decline';
      }
      $scope.analyticsStatus = value;
      stateService.setAnalyticsStatus(value);
    };

    $scope.$on('personaChanged', function() {
      $scope.personaSelectionDisabled = true;
      $timeout(function() {
        $scope.personaSelectionDisabled = false;
      }, 5000);
    });

    $scope.$on('analyticsChanged', function(data) {
      $scope.analyticsStatus = stateService.getAnalyticsStatus();
    });

    $scope.loggedInConfigs = [
      {
        'name': 'deviceAlertsNotifications',
        'content': 'Enable Device Notifications',
        'type': 'toggle',
        'value': $scope.deviceAlertsNotifications,
        'callback': $scope.toggleAlertsNotifications
      }
    ];
    $scope.persistentConfigs = [
      {
        'name': 'analyticsStatus',
        'content': 'Usage Sharing',
        'type': 'toggle',
        'value': $scope.analyticsStatus,
        'callback': $scope.toggleAnalyticsStatus
      }
    ];
  }
]);

MaddenCompanionApp.controller('AboutCtrl', ['$scope', 'messageService', '$sce', function($scope, messageService, $sce) {

  $scope.messages = [
    {
      'previewText': 'Notifications',
      'content': 'Stay in the game when you\'re on the go. Get notified of game events, friend events, auctions, special offers, and more!',
      'icon': 'img/Icons_Social_Invite.png',
      'processed': true
    },
    {
      'previewText': 'Madden NFL Mobile',
      'content': 'Experience an exciting version of Madden NFL on the go. Build your favorite team, earn rewards and dominate your opponents!',
      'icon': 'img/madden-mobile.png',
      'processed': true
    },
    {
      'previewText': 'Madden Ultimate Team',
      'content': 'Optimize the Madden Ultimate Team experience. Track collections and quickly get item stats.',
      'icon': 'img/Icons_MUT_MUT.png',
      'processed': true
    },
    {
      'previewText': 'Connected Franchise Mode',
      'content': 'Manage your team anytime, anywhere. Advance the week, view league stats & standings, handle roster transactions and more!',
      'icon': 'img/Icons_CFM_Events.png',
      'processed': true
    },
    {
      'previewText': 'CoachGlass',
      'content': 'Get and in-depth look on how your opponent is playing so you can stay one step ahead of the game.',
      'icon': 'img/madden-coachglass.png',
      'processed': true
    }
  ];

  $scope.$on('notMaddenEntitled', function() {
    $scope.messages.push($scope.maddenEntitledMessage);
    if (!$scope.$$phase) {
      $scope.$apply();
    }
  });

}]);

MaddenCompanionApp.controller('TosAcceptance', [
    '$scope',
    'stateService',
  function(
    $scope,
    stateService
  ) {

  $scope.accept = function() {
    $scope.trackButtonClick('TOS Accept');
    stateService.acceptEULA();
    navigator.splashscreen.show();
    window.location.reload();
  };

  $scope.decline = function() {
    navigator.notification.alert(
      "You must accept EA's Privacy and Cookie Policy, Terms of Service and EULA to use this app.",
      function() {},
      'Sorry...',
      'Go Back'
    );
  };

  var trackInstall = function() {
    repeatRun = localStorage.getItem('repeatRun');
    if (repeatRun != 'true') {
      stateService.setAnalyticsStatus('allow');
      $scope.trackEvent('Application', 'Event', 'Install');
      localStorage.setItem('repeatRun', 'true');
    }
  };

  var checkEULA = function() {
    status = localStorage.getItem('acceptedEULA');
    if (status == 'true') {
      window.location.href = 'main.html';
    } else {
      $scope.trackPaneLoad("TOS");
    }
  };

  $scope.tosBootstrap = function() {
    trackInstall();
    checkEULA();
  };

}]);
